#ifndef ldct_ht_h
#define ldct_ht_h

#include "p64-huff.h"

extern "C" {

extern const struct huffent hte_ldct_dchuff[];
extern const struct huffent hte_ldct_layer0[];
extern const struct huffent hte_ldct_layer1[];
extern const struct huffent hte_ldct_layer2[];

extern const int hte_ldct_dchuff_esc[];
extern const int hte_ldct_layer0_esc[];
extern const int hte_ldct_layer1_esc[];
extern const int hte_ldct_layer2_esc[];

extern const int htd_ldct_dchuff[];
extern const int htd_ldct_layer0[];
extern const int htd_ldct_layer1[];
extern const int htd_ldct_layer2[];

extern int htd_ldct_dchuff_width;
extern int htd_ldct_layer0_width;
extern int htd_ldct_layer1_width;
extern int htd_ldct_layer2_width;

}

#define LDCT_L0_LEN  (9-LDCT_L0)
#define LDCT_L1_LEN  (LDCT_L0-LDCT_L1)
#define LDCT_L2_LEN  (LDCT_L1-LDCT_L2)

#define LDCT_ACMAXCODE	10
#define LDCT_DCMAXCODE  10

#define LDCT_EOB	1023
#define LDCT_ESC        1022

#endif
