
# handoffServer 
#
# must be run as root for routing updates to work
#-----
#


import AnnounceListenManager

#
# Accepts msgs to update routing tables for manual mobility management
#
Class AnnounceListenManager/RoutingTableAgent -superclass AnnounceListenManager

# 
AnnounceListenManager/RoutingTableAgent instproc recv_announcement  {args} {
	puts "$args"
	set addr [lindex $args 0]
	set cmd [lindex $args 2]
	# ignore args port 1, length 3
	if {[llength $cmd] == 4} {
		if {[lindex $cmd 0] == "SetRoute"} {
			# Assuming '$addr == [lindex $cmd 1]' for now -- 
			# should do DNS check?
			#puts "SetRoute $addr [lindex $cmd 2]"
			eval $self SetRoute $addr [lindex $cmd 2]
		}
	}
}

#
AnnounceListenManager/RoutingTableAgent private SetRoute {client newBS} {

	puts "\[[exec date]\]: SetRoute $client $newBS"
	set client [$self NSLookup $client]
	if {[catch "exec netstat -rn | grep $client" netstatReply]} {
		puts "no route to client $client"
		if {[catch "eval exec route add $client $newBS" result]} {
			puts "Error on route add:\n$result"
		}
	} else {
		exec route delete -host $client 
		if {[catch "eval exec route add $client $newBS" result]} {
			puts "Error on route add:\n$result"
		}
	}
	return 0
}

#
AnnounceListenManager/RoutingTableAgent private NSLookup {name} {
    set firstchar [string index $name 0]
    if [string match \[a-zA-Z\] $firstchar] {
	return [gethostbyname $name]
    } else {
	return $name
    }
}

#
## ---  just start the agent in lieu of embedding in an application
#
set netObj [new AnnounceListenManager/RoutingTableAgent 4096 127.0.0.1/3443]

# run a tk event loop in tclsh 
vwait forever



