
#ifndef  MASH_RTSP_SERVER_MANAGER_H
#define MASH_RTSP_SERVER_MANAGER_H

#include "net/tcpchan.h"
#include "misc/all-types.h"
#include <tclcl.h>
#include "net/pktbuf.h"

class RTSPServer;

class RTSPServerManager : public TCPServerManager, public TclObject {
public:
	RTSPServerManager();
	~RTSPServerManager() {}
	int serverhandler(int argc, const char * const *argv);
	int attach(int argc, const char * const *argv);
	int test_receiver(int argc, const char * const *argv);
	virtual void recv(TCPServerHandler* sh);
	int reply(int argc, const char * const *argv);
	int reset(int argc, const char * const *argv);
	
protected:
	
	TCPServerHandler *handler_;
	RTSPServer* server_;
	BufferPool* pool_;
	int temp_;
	
};





#endif
